import Vue from 'vue';
import VueRouter from 'vue-router';
import NProgress from 'nprogress';
import 'nprogress/nprogress.css';
import store from './store';
Vue.use(VueRouter);
const router = new VueRouter();
export default router;
router.beforeEach((to, from, next) => {
  NProgress.start();
  store.commit('d2admin/search/set', false);

  if (to.name === '404') {
    if (!from.name) {
      next();
    } else {
      next(new Error(`访问路径 “${to.fullPath}” 不存在，如有疑问请与管理员联系`));
      NProgress.done();
    }
  } else if (to.meta.auth) {
    if (store.getters && store.getters['session/loggedIn']) {
      if (to.meta.auth !== 'check' || checkPermission(to.fullPath)) {
        next();
      } else {
        if (!from.name) {
          next({
            name: '403',
            params: {
              path: to.fullPath
            }
          });
        } else {
          next(new Error(`未授权访问 “${to.fullPath}”，如有疑问请与管理员联系`));
        }

        NProgress.done();
      }
    } else {
      let path = {
        name: 'login'
      };

      if (to.fullPath !== '/' && to.fullPath !== '/index') {
        path.query = {
          redirect: to.fullPath
        };
      }

      next(path);
      NProgress.done();
    }
  } else {
    next();
  }
});
router.afterEach(to => {
  NProgress.done();
  store.dispatch('d2admin/page/open', to);
  util.title(to.meta.title);
});
router.onError(err => {
  router.app.$message.error(err.message);
  Vue.config.errorHandler(err, router, err.message);
});